----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    16:38:58 04/14/2007 
-- Design Name: 
-- Module Name:    DCOL_sim - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.DCOL_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity DCOL_sim is
	PORT(
		clkin : IN std_logic;
		reset_b : IN std_logic;
		TRIG_clk_p : IN std_logic;
		TRIG_clk_n : IN std_logic;
		TRIG_din_p : IN std_logic_vector(1 downto 0);
		TRIG_din_n : IN std_logic_vector(1 downto 0);
		DCON_rx_in : IN std_logic_vector(12 downto 1);
		SN : IN std_logic_vector(7 downto 0);
		SW_BAR : IN std_logic_vector(4 downto 0);
		SW_use : IN std_logic;
		V50_ready : IN std_logic;    
		vme_pads : INOUT vme_pad;
		M_Q : IN std_logic;      
		TRIG_dout_p : OUT std_logic;
		TRIG_dout_n : OUT std_logic;
		DCON_tx_p : OUT std_logic_vector(12 downto 1);
		DCON_tx_n : OUT std_logic_vector(12 downto 1);
		DCON_test_p : OUT std_logic_vector(12 downto 1);
		DCON_test_n : OUT std_logic_vector(12 downto 1);
		DCON_pem : OUT std_logic_vector(1 downto 0);
		V50_ON : OUT std_logic;
		MCLK : OUT std_logic;
		MD : OUT std_logic;
		MS_n : OUT std_logic;
		MW_n : OUT std_logic;
		MH_n : OUT std_logic;
		CCLK : OUT std_logic;
		PROG_b : OUT std_logic
		);
end DCOL_sim;

architecture Behavioral of DCOL_sim is
component ddrram 
    Port (
		mem_pads : INOUT mem_pad);
end component;
COMPONENT DCOL
    generic (swap_byte : boolean := false; swap_lw : boolean := false; sim : boolean := false);
	PORT(
		clkin : IN std_logic;
		TRIG_clk_p : IN std_logic;
		TRIG_clk_n : IN std_logic;
		TRIG_din_p : IN std_logic_vector(1 downto 0);
		TRIG_din_n : IN std_logic_vector(1 downto 0);
		DCON_rx_in : IN std_logic_vector(12 downto 1);
		SN : IN std_logic_vector(7 downto 0);
		SW_BAR : IN std_logic_vector(4 downto 0);
		SW_use : IN std_logic;
		V50_ready : IN std_logic;    
		vme_pads : INOUT vme_pad;
		mem_pads : INOUT mem_pad;
		CPLD_ctrl : INOUT std_logic_vector(4 downto 0);
		M_Q : IN std_logic;      
		TRIG_dout_p : OUT std_logic;
		TRIG_dout_n : OUT std_logic;
		DCON_tx_p : OUT std_logic_vector(12 downto 1);
		DCON_tx_n : OUT std_logic_vector(12 downto 1);
		DCON_test_p : OUT std_logic_vector(12 downto 1);
		DCON_test_n : OUT std_logic_vector(12 downto 1);
		DCON_pem : OUT std_logic_vector(1 downto 0);
		V50_ON : OUT std_logic;
		INIT_b : OUT std_logic
		);
END COMPONENT;
COMPONENT DCOL_conf
	PORT(
		reset_b : IN std_logic;
		clk : IN std_logic;
		INIT_b : IN std_logic;
		DONE : IN std_logic;    
		FPGA_ctrl : INOUT std_logic_vector(4 downto 0);      
		MCLK : OUT std_logic;
		MD : OUT std_logic;
		MS_n : OUT std_logic;
		MW_n : OUT std_logic;
		MH_n : OUT std_logic;
		CCLK : OUT std_logic;
		PROG_b : OUT std_logic
		);
END COMPONENT;
signal mem_pads : mem_pad;
signal CPLD_ctrl : std_logic_vector(4 downto 0) := (others => '1');
signal INIT_b : std_logic  := '0';

begin
Inst_ddrram: ddrram
    port map(
	   mem_pads => mem_pads
	 );
Inst_DCOL: DCOL
	generic map(sim => true)
	PORT MAP(
		vme_pads => vme_pads,
		clkin => clkin,
		TRIG_clk_p => TRIG_clk_p,
		TRIG_clk_n => TRIG_clk_n,
		TRIG_din_p => TRIG_din_p,
		TRIG_din_n => TRIG_din_n,
		TRIG_dout_p => TRIG_dout_p,
		TRIG_dout_n => TRIG_dout_n,
		DCON_rx_in => DCON_rx_in,
		DCON_tx_p => DCON_tx_p,
		DCON_tx_n => DCON_tx_n,
		DCON_test_p => DCON_test_p,
		DCON_test_n => DCON_test_n,
		DCON_pem => DCON_pem,
		SN => SN,
		SW_BAR => SW_BAR,
		SW_use => SW_use,
		V50_ready => V50_ready,
		V50_ON => V50_ON,
		mem_pads => mem_pads,
		INIT_b => INIT_b,
		CPLD_ctrl => cpld_ctrl,
		M_Q => M_Q
	);
i_DCOL_conf: DCOL_conf PORT MAP(
		reset_b => reset_b,
		clk => clkin,
		MCLK => MCLK,
		MD => MD,
		MS_n => MS_n,
		MW_n => MW_n,
		MH_n => MH_n,
		INIT_b => INIT_b,
		DONE => '1',
		FPGA_ctrl => cpld_ctrl,
		cclk => cclk,
		prog_b => prog_b
	);


end Behavioral;

