--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   12:55:58 04/03/2008
-- Design Name:   
-- Module Name:   C:/iseproj/DCOL/counters_tb.vhd
-- Project Name:  DCOL
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: counters
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY counters_tb IS
END counters_tb;
 
ARCHITECTURE behavior OF counters_tb IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
 
    COMPONENT counters
    PORT(
         clk : IN  std_logic;
         reset : IN  std_logic;
         n_strobe : IN  std_logic;
         addr : IN  std_logic_vector(22 downto 0);
         trig_clk : IN  std_logic;
         hit_gnt : IN  std_logic_vector(3 downto 0);
         dcon_if_cnt : IN  std_logic_vector(5 downto 0);
         DCON_err : IN  std_logic;
         DCON_addr : IN  std_logic_vector(5 downto 0);
         DCON_we : IN  std_logic_vector(2 downto 0);
         mon_data : OUT  std_logic_vector(31 downto 0)
        );
    END COMPONENT;
    

   --Inputs
   signal clk : std_logic := '0';
   signal reset : std_logic := '1';
   signal n_strobe : std_logic := '0';
   signal addr : std_logic_vector(22 downto 0) := (others => '0');
   signal trig_clk : std_logic := '0';
   signal hit_gnt : std_logic_vector(3 downto 0) := (others => '0');
   signal dcon_if_cnt : std_logic_vector(5 downto 0) := (others => '0');
   signal DCON_err : std_logic := '0';
   signal DCON_addr : std_logic_vector(5 downto 0) := (others => '0');
   signal DCON_we : std_logic_vector(2 downto 0) := (others => '0');

 	--Outputs
   signal mon_data : std_logic_vector(31 downto 0);

   -- Clock period definitions
   constant clk_period : time := 8ns;
   constant trig_clk_period : time := 8ns;
   signal cntr : std_logic_vector(15 downto 0) := (others => '0');
   signal counter : std_logic_vector(15 downto 0) := (others => '0');
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
   uut: counters PORT MAP (
          clk => clk,
          reset => reset,
          n_strobe => n_strobe,
          addr => addr,
          trig_clk => trig_clk,
          hit_gnt => hit_gnt,
          dcon_if_cnt => dcon_if_cnt,
          DCON_err => DCON_err,
          DCON_addr => DCON_addr,
          DCON_we => DCON_we,
          mon_data => mon_data
        );

   -- Clock process definitions
   clk_process :process
   begin
		clk <= '0';
		wait for clk_period/2;
		clk <= '1';
		wait for clk_period/2;
   end process;
 
   trig_clk_process :process
   begin
		trig_clk <= '0';
		wait for trig_clk_period/2;
		trig_clk <= '1';
		wait for trig_clk_period/2;
   end process;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    cntr <= cntr + 1;
	 if(cntr > x"0050" and cntr(7 downto 4) = x"1" and cntr(3 downto 2) /= "11")then
	   dcon_if_cnt <= cntr(8) & not cntr(8) & cntr(3 downto 0);
	 else
	   dcon_if_cnt <= "000000";
	 end if;
  end if;
end process;
process(clk)
begin
  if(clk'event and clk = '1')then
    n_strobe <= not n_strobe;
	 if(reset = '1')then
	   counter <= (others => '0');
	 elsif(n_strobe = '0')then
	   counter <= counter + 1;
	 end if;
	 if(n_strobe = '0')then
		 if(counter > x"0040" and counter(4) /= counter(3))then
			hit_gnt(3) <= counter(7) and counter(6);
			hit_gnt(2) <= counter(7) and not counter(6);
			hit_gnt(1) <= not counter(7) and counter(6);
			hit_gnt(0) <= not counter(7) and not counter(6);
		 else
			hit_gnt <= "0000";
		 end if;
		 if(counter > x"0040" and counter(4) = '1')then
			DCON_we(2) <= counter(7);
			DCON_we(1) <= not counter(7) and counter(6);
			DCON_we(0) <= not counter(7) and not counter(6);
		 else
			DCON_we <= "000";
		 end if;
		 if(counter > x"0040" and counter(4 downto 0) = "10000")then
			DCON_err <= '1';
		 else
			DCON_err <= '0';
		 end if;
		 if(DCON_we /= "000")then
			DCON_addr <= DCON_addr + 1;
		 end if;
	 end if;
  end if;
end process; 

   -- Stimulus process
   stim_proc: process
   begin		
      -- hold reset state for 100ms.
      wait for 100ns;	
        reset <= '0';
      wait for clk_period*10;

      -- insert stimulus here 

      wait;
   end process;

END;
