
--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   14:59:59 03/12/2008
-- Design Name:   DCON_if
-- Module Name:   C:/iseproj/DCOL/dcon_if_tb.vhd
-- Project Name:  DCOL
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: DCON_if
--
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends 
-- that these types always be used for the top-level I/O of a design in order 
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;

ENTITY dcon_if_tb_vhd IS
END dcon_if_tb_vhd;

ARCHITECTURE behavior OF dcon_if_tb_vhd IS 

	-- Component Declaration for the Unit Under Test (UUT)
	COMPONENT DCON_if
	PORT(
		clk : IN std_logic;
		reset : IN std_logic;
		n_strobe : IN std_logic;
		start_bit : IN std_logic;
		trig_clk : IN std_logic;
		trig_d0 : IN std_logic;
		sel_reg : IN std_logic;
    DCOLAD : in  STD_LOGIC_VECTOR (3 downto 0);
		addr : IN std_logic_vector(22 downto 0);
		w_data : IN std_logic_vector(31 downto 0);
		we_byte : IN std_logic_vector(3 downto 0);
		DCON_en : IN std_logic_vector(12 downto 1);
		DCON_rx : IN std_logic_vector(12 downto 1);
		buf_full : IN std_logic;          
		ctrl_tx_data : OUT std_logic_vector(31 downto 0);
		ctrl_rx_data : OUT std_logic_vector(31 downto 0);
		DCON_tx : OUT std_logic_vector(12 downto 1);
		ctrl_tx_csr : OUT std_logic_vector(31 downto 0);
		ctrl_rx_csr : OUT std_logic_vector(11 downto 0);
		mon_cntr : OUT std_logic_vector(6 downto 0);
		DCON_err : OUT std_logic;
		DCON_data : OUT std_logic_vector(8 downto 0);
		DCON_addr : OUT std_logic_vector(5 downto 0);
		DCON_we : OUT std_logic_vector(2 downto 0)
		);
	END COMPONENT;

	--Inputs
	SIGNAL clk :  std_logic := '0';
	SIGNAL reset :  std_logic := '1';
	SIGNAL n_strobe :  std_logic := '0';
	SIGNAL start_bit :  std_logic := '0';
	SIGNAL trig_clk :  std_logic := '0';
	SIGNAL trig_d0 :  std_logic := '0';
	SIGNAL sel_reg :  std_logic := '0';
	SIGNAL buf_full :  std_logic := '0';
	SIGNAL addr :  std_logic_vector(22 downto 0) := (others=>'0');
	SIGNAL w_data :  std_logic_vector(31 downto 0) := (others=>'0');
	SIGNAL we_byte :  std_logic_vector(3 downto 0) := (others=>'0');
	SIGNAL DCON_en :  std_logic_vector(12 downto 1) := (others=>'1');
	SIGNAL DCON_rx :  std_logic_vector(12 downto 1) := (others=>'0');

	--Outputs
	SIGNAL ctrl_tx_data :  std_logic_vector(31 downto 0);
	SIGNAL ctrl_rx_data :  std_logic_vector(31 downto 0);
	SIGNAL DCON_tx :  std_logic_vector(12 downto 1);
	SIGNAL ctrl_tx_csr :  std_logic_vector(31 downto 0);
	SIGNAL ctrl_rx_csr :  std_logic_vector(11 downto 0);
	SIGNAL mon_cntr :  std_logic_vector(6 downto 0);
	SIGNAL DCON_err :  std_logic;
	SIGNAL DCON_data :  std_logic_vector(8 downto 0);
	SIGNAL DCON_addr :  std_logic_vector(5 downto 0);
	SIGNAL DCON_we :  std_logic_vector(2 downto 0);

SIGNAL cntr :  std_logic_vector(15 downto 0) := x"0000";
SIGNAL div12 :  std_logic_vector(3 downto 0) := x"0";
BEGIN

	-- Instantiate the Unit Under Test (UUT)
	uut: DCON_if PORT MAP(
		clk => clk,
		reset => reset,
		n_strobe => n_strobe,
		start_bit => start_bit,
		trig_clk => trig_clk,
		trig_d0 => trig_d0,
		sel_reg => sel_reg,
		addr => addr,
		w_data => w_data,
		we_byte => we_byte,
		ctrl_tx_data => ctrl_tx_data,
		ctrl_rx_data => ctrl_rx_data,
		DCOLAD => x"c",
		DCON_en => DCON_en,
		DCON_rx => DCON_rx,
		DCON_tx => DCON_tx,
		ctrl_tx_csr => ctrl_tx_csr,
		ctrl_rx_csr => ctrl_rx_csr,
		mon_cntr => mon_cntr,
		buf_full => buf_full,
		DCON_err => DCON_err,
		DCON_data => DCON_data,
		DCON_addr => DCON_addr,
		DCON_we => DCON_we
	);
trig_clk <= not trig_clk after 4ns;
process(trig_clk)
begin
  if(trig_clk'event and trig_clk = '1')then
    if(start_bit = '1')then
      div12 <= x"0";
	 else
      div12 <= div12 + 1;
	 end if;
	 if(div12 = x"a")then
	   start_bit <= '1';
	 else
	   start_bit <= '0';
	 end if;
--	 if(div12 = x"a" or (cntr >= x"0010" and cntr /= x"0090" and cntr <= x"0110" and div12 = x"4"))then
	 if(div12 = x"a" or (cntr >= x"0010" and cntr < x"0110" and div12 = x"4") or (cntr >= x"0010" and cntr < x"0090" and div12 = x"7"))then
	   dcon_rx <= x"fff";
	 elsif(div12 = x"1" or div12 = x"4" or div12 = x"7")then
	   dcon_rx <= x"fff";
	 else
	   dcon_rx <= x"000";
	 end if;
	 if(start_bit = '1')then
	   cntr <= cntr + 1;
	 end if;
  end if;
end process;
clk <= not clk after 4ns;
process(clk)
begin
  if(clk'event and clk = '1')then
    n_strobe <= not n_strobe;
  end if;
end process;
	tb : PROCESS
	BEGIN

		-- Wait 100 ns for global reset to finish
		wait for 50 ns;
		reset <= '0';

		-- Place stimulus here

		wait; -- will wait forever
	END PROCESS;

END;
