----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:45:58 09/30/2009 
-- Design Name: 
-- Module Name:    rx_in_sim - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity rx_in_sim is
    Port ( clk : in  STD_LOGIC;
           en_clk : in  STD_LOGIC;
           dcon_in : out  STD_LOGIC);
end rx_in_sim;

architecture Behavioral of rx_in_sim is
signal f_cntr : std_logic_vector(7 downto 0) := (others => '0');
signal div3 : std_logic_vector(1 downto 0) := (others => '0');
signal div4 : std_logic_vector(1 downto 0) := (others => '0');
signal DCALAD : std_logic_vector(4 downto 0) := (others => '0');
signal TS : std_logic_vector(23 downto 0) := (others => '0');
signal HIT : std_logic_vector(63 downto 0) := (others => '0');
signal ERR : std_logic_vector(2 downto 0) := (others => '0');
signal chksum : std_logic_vector(7 downto 0) := (others => '0');
signal en_data : std_logic := '0';
signal en_ctrl : std_logic := '0';
signal d_out : std_logic := '0';
begin
process(clk,en_clk)
begin
	if(en_clk = '0')then
		div3 <= "00";
		div4 <= "00";
		f_cntr <= x"00";
		dcon_in <= '0';
		TS <= (others => '0');
		HIT <= x"0000000000000001";
		DCALAD <= (others => '0');
	elsif(clk'event and clk = '1')then
		if(div3(1) = '1')then
			div3 <= "00";
			div4 <= div4 + 1;
			if(div4 = "11")then
				if(f_cntr = x"af")then
					f_cntr <= x"00";
					TS <= TS + 1;
					HIT <= HIT(62 downto 0) & HIT(63);
					DCALAD <= DCALAD + 1;
				else
					f_cntr <= f_cntr + 1;
				end if;
			end if;
			case div4 is
				when "00" => dcon_in <= '1';
				when "01" => dcon_in <= en_ctrl;
				when "10" => dcon_in <= en_data;
				when others => dcon_in <= d_out;
			end case;
		else
			div3 <= div3 + 1;
		end if;
	end if;
end process;
process(clk)
begin
	if(clk'event and clk = '1')then
		en_data <= not f_cntr(7);
		if(f_cntr > x"82" and f_cntr < x"a3")then
			en_ctrl <= '1';
		else
			en_ctrl <= '0';
		end if;
		if(div3(1) = '1' and div4 = "11")then
			if(f_cntr = x"07")then
				chksum <= "100" & DCALAD;
			elsif(f_cntr = x"17")then
				chksum <= chksum + TS(23 downto 16);
			elsif(f_cntr = x"1f")then
				chksum <= chksum + TS(15 downto 8);
			elsif(f_cntr = x"27")then
				chksum <= chksum + TS(7 downto 0);
			elsif(f_cntr = x"2f")then
				chksum <= chksum + HIT(63 downto 56);
			elsif(f_cntr = x"37")then
				chksum <= chksum + HIT(55 downto 48);
			elsif(f_cntr = x"3f")then
				chksum <= chksum + HIT(47 downto 40);
			elsif(f_cntr = x"47")then
				chksum <= chksum + HIT(39 downto 32);
			elsif(f_cntr = x"4f")then
				chksum <= chksum + HIT(31 downto 24);
			elsif(f_cntr = x"57")then
				chksum <= chksum + HIT(23 downto 16);
			elsif(f_cntr = x"5f")then
				chksum <= chksum + HIT(15 downto 8);
			elsif(f_cntr = x"67")then
				chksum <= chksum + HIT(7 downto 0);
			elsif(f_cntr = x"77")then
				chksum <= chksum + ("00000" & err);
			end if;
		end if;
		if(f_cntr = x"00" or f_cntr = x"83")then
			d_out <= '1';
		elsif(f_cntr > x"02" and f_cntr < x"08")then
			d_out <= DCALAD(7-CONV_INTEGER(f_cntr(2 downto 0)));
		elsif(f_cntr > x"0f" and f_cntr < x"28")then
			d_out <= TS(39-CONV_INTEGER(f_cntr(5 downto 0)));
		elsif(f_cntr > x"27" and f_cntr < x"68")then
			d_out <= HIT(103-CONV_INTEGER(f_cntr(6 downto 0)));
		elsif(f_cntr > x"77" and f_cntr < x"80")then
			d_out <= chksum(7-CONV_INTEGER(f_cntr(2 downto 0)));
		else
			d_out <= '0';
		end if;
	end if;
end process;

end Behavioral;

