----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    19:19:36 03/24/2007 
-- Design Name: 
-- Module Name:    trig_ctrl - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE,mylib;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;
use mylib.DCOL_pack.all;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity trig_ctrl is
    Port ( clk : in  STD_LOGIC;
           trig_in : in  STD_LOGIC;
           stand_alone : in  STD_LOGIC;
           second : in  STD_LOGIC;
			  DCON_en : in STD_LOGIC_VECTOR(12 downto 1);
           test_out : out  STD_LOGIC_VECTOR(12 downto 1);
           trig_out : out  STD_LOGIC;
           start_bit : out  STD_LOGIC);
end trig_ctrl;

architecture Behavioral of trig_ctrl is
signal div : std_logic_vector(1 downto 0) := (others => '0');
signal div4 : std_logic_vector(1 downto 0) := (others => '0');
signal trig_in_q :std_logic_vector(2 downto 0) := (others => '0');
signal cntr_a : std_logic_vector(3 downto 0) := (others => '0');
signal cntr_b : std_logic_vector(3 downto 0) := (others => '0');
signal trig_out_i : std_logic := '0';
signal test_out_i : std_logic := '0';
begin
i_trig_out: delayN
  generic map(N=> 3) port map(d => trig_out_i, ce => '1', c => clk, q => trig_out);
process(clk)
begin
  if(clk'event and clk = '1')then
    trig_in_q(0) <= trig_in;
	 if(stand_alone = '1' or cntr_a(3) = '1')then
	   cntr_a <= x"0";
--	 elsif(trig_in_q(0) /= trig_in)then
	 elsif(trig_in_q(0) = '0' and trig_in = '1')then -- check rising edge only
	   if(div(1) = '0')then
		  cntr_a <= cntr_a + 1;
		elsif(cntr_a /= x"0")then
		  cntr_a <= cntr_a - 1;
	   end if;
	 end if;
	 if(cntr_a(3) = '0')then
	   if(div(1) = '1')then
	     div <= "00";
		else  
	     div <= div + 1;
		end if;
	 end if;
	 if(div = "00")then
	   if(stand_alone = '1' or cntr_b(3) = '1')then
	     cntr_b <= x"0";
	   elsif(div4 = "00")then
	     if(trig_in = '0')then
		    cntr_b <= cntr_b + 1;
		  elsif(cntr_b /= x"0")then
		    cntr_b <= cntr_b - 1;
	     end if;
	   end if;
	   if(cntr_b(3) = '0')then
		  div4 <= div4 + 1;
		end if;
		if(div4 = "00")then
		  trig_in_q(2 downto 1) <= trig_in_q(1 downto 0);
		end if;
	 end if;
	 if(div(1) = '1' and div4 = "01")then
	   test_out_i <= '1';
	 end if;
	 if(test_out_i = '0')then
	   test_out <= (others => '0');
	 else
	   test_out <= DCON_en;
	 end if;
	 if(div(0) = '1')then
	   trig_out_i <= '1';
	 elsif(div(1) = '1')then
	   if(stand_alone = '0')then
	     if(div4 = "01")then
		    trig_out_i <= '0';
		  else
		    trig_out_i <= trig_in;
		  end if;
		elsif(div4 = "00" or (div4 = "10" and second = '1') or (div4 = "11" and trig_in_q(2 downto 1) = "01"))then
		  trig_out_i <= '1';
		else
		  trig_out_i <= '0';
		end if;
	 else
	   trig_out_i <= '0';
	 end if;
	 start_bit <= div(0) and not div4(1) and div4(0);
  end if;
end process;

end Behavioral;

